diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/make/Makefile.osx olsrd-current/make/Makefile.osx
--- olsrd-0.5.3/make/Makefile.osx	2007-07-26 19:34:54.000000000 +0200
+++ olsrd-current/make/Makefile.osx	2007-08-29 23:46:26.000000000 +0200
@@ -25,6 +25,7 @@
 endif
 
 OS_LIB_PTHREAD =
+OS_CFLAG_PTHREAD =
 OS_LIB_DYNLOAD =
 
 # Local Variables:
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/make/Makefile.win32 olsrd-current/make/Makefile.win32
--- olsrd-0.5.3/make/Makefile.win32	2007-07-26 19:34:54.000000000 +0200
+++ olsrd-current/make/Makefile.win32	2007-08-29 23:46:26.000000000 +0200
@@ -23,6 +23,7 @@
 endif
 
 OS_LIB_PTHREAD =
+OS_CFLAG_PTHREAD =
 OS_LIB_DYNLOAD =
 
 olsr-$(VERS).zip:	gui/win32/release/Main.exe \
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/make/Makefile.wince olsrd-current/make/Makefile.wince
--- olsrd-0.5.3/make/Makefile.wince	2007-07-26 19:34:54.000000000 +0200
+++ olsrd-current/make/Makefile.wince	2007-08-29 23:46:26.000000000 +0200
@@ -19,6 +19,7 @@
 endif
 
 OS_LIB_PTHREAD =
+OS_CFLAG_PTHREAD =
 OS_LIB_DYNLOAD =
 
 # Local Variables:
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/Makefile olsrd-current/Makefile
--- olsrd-0.5.3/Makefile	2007-08-02 23:00:49.000000000 +0200
+++ olsrd-current/Makefile	2007-08-30 00:26:11.000000000 +0200
@@ -35,34 +35,33 @@
 # to the project. For more information see the website or contact
 # the copyright holders.
 #
-# $Id: Makefile,v 1.90 2007/08/02 20:53:20 bernd67 Exp $
+# $Id: Makefile,v 1.95 2007/08/29 22:26:11 bernd67 Exp $
 
-VERS =		0.5.3
-
-all:
+VERS =		0.5.4pre
 
 TOPDIR = .
 include Makefile.inc
 
 CPPFLAGS +=	-DVERSION=\"$(VERS)\"
 
+# pass generated variables to save time
 MAKECMD = $(MAKE) OS="$(OS)" WARNINGS="$(WARNINGS)"
 
-LIBS +=		$(OS_LIB_DYNLOAD)
+LIBS +=		$(OS_LIB_DYNLOAD) $(OS_LIB_PTHREAD)
 
 ifeq ($(OS), win32)
 LDFLAGS +=	-Wl,--out-implib=libolsrd.a -Wl,--export-all-symbols
 endif
 
-SWITCHDIR =     src/olsr_switch
+SWITCHDIR =	src/olsr_switch
 CFGDIR =	src/cfgparser
 CFGOBJS = 	$(CFGDIR)/oscan.o $(CFGDIR)/oparse.o $(CFGDIR)/olsrd_conf.o
-CFGDEPS = 	$(wildcard $(CFGDIR)/*.c) $(wildcard $(CFGDIR)/*.h) $(CFGDIR)/oparse.y $(CFGDIR)/oscan.lex
-TAG_SRCS = $(SRCS) $(HDRS) $(wildcard src/cfgparser/*.c) $(wildcard src/cfgparser/*.h) $(wildcard src/olsr_switch/*.c) $(wildcard src/olsr_switch/*.h)
+CFGDEPS = 	$(wildcard $(CFGDIR)/*.[ch]) $(CFGDIR)/oparse.y $(CFGDIR)/oscan.lex
+TAG_SRCS =	$(SRCS) $(HDRS) $(wildcard $(CFGDIR)/*.[ch] $(SWITCHDIR)/*.[ch])
 
-default_target: cfgparser olsrd
+default_target: cfgparser $(EXENAME)
 
-olsrd:		$(OBJS) $(CFGOBJS)
+$(EXENAME):	$(OBJS) $(CFGOBJS)
 		$(CC) $(LDFLAGS) -o $@ $(OBJS) $(CFGOBJS) $(LIBS)
 
 cfgparser:	$(CFGDEPS)
@@ -77,7 +76,10 @@
 .PHONY: help libs clean_libs libs_clean clean uberclean install_libs libs_install install_bin install_olsrd install build_all install_all clean_all 
 
 clean:
-		-rm -f $(OBJS) $(SRCS:%.c=%.d) olsrd olsrd.exe
+		-rm -f $(OBJS) $(SRCS:%.c=%.d) $(EXENAME) $(EXENAME).exe
+ifeq ($(OS), win32)
+		-rm -f libolsrd.a
+endif
 		$(MAKECMD) -C $(CFGDIR) clean
 
 uberclean:	clean clean_libs
@@ -95,7 +97,7 @@
 
 install_olsrd:	install_bin
 		@echo ========= C O N F I G U R A T I O N - F I L E ============
-		@echo olsrd uses the configfile $(CFGFILE)
+		@echo $(EXENAME) uses the configfile $(CFGFILE)
 		@echo a default configfile. A sample RFC-compliance aimed
 		@echo configfile can be installed. Note that a LQ-based configfile
 		@echo can be found at files/olsrd.conf.default.lq
@@ -105,11 +107,11 @@
 		@echo -------------------------------------------
 		@echo Edit $(CFGFILE) before running olsrd!!
 		@echo -------------------------------------------
-		@echo Installing manpages olsrd\(8\) and olsrd.conf\(5\)
+		@echo Installing manpages $(EXENAME)\(8\) and $(CFGNAME)\(5\)
 		mkdir -p $(MANDIR)/man8/
-		cp files/olsrd.8.gz $(MANDIR)/man8/olsrd.8.gz
+		cp files/olsrd.8.gz $(MANDIR)/man8/$(EXENAME).8.gz
 		mkdir -p $(MANDIR)/man5/
-		cp files/olsrd.conf.5.gz $(MANDIR)/man5/olsrd.conf.5.gz
+		cp files/olsrd.conf.5.gz $(MANDIR)/man5/$(CFGNAME).5.gz
 
 tags:
 		$(TAGCMD) -o $(TAGFILE) $(TAG_SRCS)
@@ -181,6 +183,6 @@
 		$(MAKECMD) -C lib/quagga DESTDIR=$(DESTDIR) install 
 
 
-build_all:	cfgparser olsrd libs switch
+build_all:	all cfgparser $(EXENAME) switch libs
 install_all:	install install_libs
 clean_all:	uberclean clean_libs
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/Makefile.inc olsrd-current/Makefile.inc
--- olsrd-0.5.3/Makefile.inc	2007-08-02 14:31:38.000000000 +0200
+++ olsrd-current/Makefile.inc	2007-08-29 23:46:25.000000000 +0200
@@ -1,5 +1,5 @@
 # programs
-CCACHE ?=       $(shell sh -c "type -path ccache")
+CCACHE ?=       $(shell bash -c "type -path ccache")
 ifeq ($(origin CC),default)
 CC = 		$(CCACHE) gcc
 else
@@ -17,10 +17,11 @@
 LIBDIR  ?= $(DESTDIR)/usr/lib
 DOCDIR  ?= $(DESTDIR)/usr/share/doc
 MANDIR  ?= $(DESTDIR)/usr/share/man
-CFGFILE ?= $(ETCDIR)/olsrd.conf
 EXENAME ?= olsrd
+CFGNAME ?= $(EXENAME).conf
+CFGFILE ?= $(ETCDIR)/$(CFGNAME)
 
-CPPFLAGS =	-Isrc -I$(TOPDIR)/src 
+CPPFLAGS =	-Isrc -I$(TOPDIR)/src
 
 # add gcc warnings and optimizations if CFLAGS not set
 ifndef CFLAGS
@@ -48,7 +49,11 @@
 endif
 CFLAGS +=	$(WARNINGS)
 CFLAGS +=	-O2
-CFLAGS +=	-g
+#CFLAGS +=	-g
+CFLAGS +=	$(EXTRA_CFLAGS)
+
+# Must be specified along with -lpthread on linux
+CPPFLAGS +=	$(OS_CFLAG_PTHREAD)
 endif
 
 ifdef OLSRD_PLUGIN
@@ -72,8 +77,6 @@
 SRCS +=		$(wildcard src/*.c *.c)
 HDRS +=		$(wildcard src/*.h *.h)
 
-all: default_target
-
 # OS detection
 ifeq ($(OS),Windows_NT)
 OS := win32
@@ -85,8 +88,8 @@
 all: help
 else
 # include OS specifics
-include $(TOPDIR)/make/Makefile.$(OS)
 all: default_target
+include $(TOPDIR)/make/Makefile.$(OS)
 endif
 
 # one object for each source file
@@ -102,7 +105,7 @@
 
 # fully automatic and working dependency generation
 %.d: %.c
-	@$(CC) -M $(CPPFLAGS) "$<" | sed -e '1s|\($(*F)\)\.o[ :]*|$(*D)/\1.o $@: Makefile $(TOPDIR)$(if $(TOPDIR),/)Makefile.inc \\\n  |g' >"$@"
+	@$(CC) -M $(CPPFLAGS) "$<" | sed -e '1s|\($(*F)\)\.o[ :]*|$(*D)/\1.o $@: Makefile $(TOPDIR)$(if $(TOPDIR),/)Makefile.inc |g' >"$@"
 
 # we always need the includes and defines
 # for legacy since now
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/defs.h olsrd-current/src/defs.h
--- olsrd-0.5.3/src/defs.h	2007-05-02 10:06:28.000000000 +0200
+++ olsrd-current/src/defs.h	2007-08-20 01:00:22.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: defs.h,v 1.60 2007/05/02 08:06:28 bernd67 Exp $
+ * $Id: defs.h,v 1.62 2007/08/19 23:00:22 bernd67 Exp $
  */
 
 
@@ -107,15 +107,15 @@
 /* First "argument" is NOT a pointer! */
 
 #define QUEUE_ELEM(pre, new) do { \
-    pre.next->prev = new;         \
-    new->next = pre.next;         \
-    new->prev = &pre;             \
-    pre.next = new;               \
+    (pre).next->prev = (new);         \
+    (new)->next = (pre).next;         \
+    (new)->prev = &(pre);             \
+    (pre).next = (new);               \
   } while (0)
 
 #define DEQUEUE_ELEM(elem) do { \
-    elem->prev->next = elem->next;     \
-    elem->next->prev = elem->prev;     \
+    (elem)->prev->next = (elem)->next;     \
+    (elem)->next->prev = (elem)->prev;     \
   } while (0)
 
 
@@ -132,6 +132,11 @@
 extern struct timeval now;	       /* current idea of time */
 extern struct tm *nowtm;	       /* current idea of time (in tm) */
 
+#if defined WIN32
+extern olsr_bool olsr_win32_end_request;
+extern olsr_bool olsr_win32_end_flag;
+#endif
+
 /*
  *IPC functions
  *These are moved to a plugin soon
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/hashing.c olsrd-current/src/hashing.c
--- olsrd-0.5.3/src/hashing.c	2007-08-02 16:47:26.000000000 +0200
+++ olsrd-current/src/hashing.c	2007-08-02 23:59:59.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: hashing.c,v 1.15 2007/08/02 14:47:26 bernd67 Exp $
+ * $Id: hashing.c,v 1.16 2007/08/02 21:59:59 bernd67 Exp $
  */
 
 #include "olsr_protocol.h"
@@ -58,7 +58,7 @@
         hash = v4x[0] ^ v4x[1] ^ v4x[2] ^ v4x[3];
     } else {
         /* IPv6 */
-        const char * const tmp = (char *)&address->v6;
+        const char * const tmp = (const char *)&address->v6;
         hash = ntohl(*tmp);
     }
     return hash & HASHMASK;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/hna_set.c olsrd-current/src/hna_set.c
--- olsrd-0.5.3/src/hna_set.c	2007-04-26 00:08:08.000000000 +0200
+++ olsrd-current/src/hna_set.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: hna_set.c,v 1.19 2007/04/25 22:08:08 bernd67 Exp $
+ * $Id: hna_set.c,v 1.20 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -55,7 +55,7 @@
 olsr_init_hna_set(void)
 {
 
-  int index;
+  int idx;
 
   if(olsr_cnf->ip_version == AF_INET)
     {
@@ -71,10 +71,10 @@
    */
   olsr_register_scheduler_event(&olsr_time_out_hna_set, NULL, 1, 0, NULL);
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      hna_set[index].next = &hna_set[index];
-      hna_set[index].prev = &hna_set[index];
+      hna_set[idx].next = &hna_set[idx];
+      hna_set[idx].prev = &hna_set[idx];
     }
 
   return 1;
@@ -267,13 +267,13 @@
 void
 olsr_time_out_hna_set(void *foo __attribute__((unused)))
 {
-  int index;
+  int idx;
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      struct hna_entry *tmp_hna = hna_set[index].next;
+      struct hna_entry *tmp_hna = hna_set[idx].next;
       /* Check all entrys */
-      while(tmp_hna != &hna_set[index])
+      while(tmp_hna != &hna_set[idx])
 	{
 	  /* Check all networks */
 	  struct hna_net *tmp_net = tmp_hna->networks.next;
@@ -321,7 +321,7 @@
 void
 olsr_print_hna_set(void)
 {
-  int index;
+  int idx;
 
   OLSR_PRINTF(1, "\n--- %02d:%02d:%02d.%02d ------------------------------------------------- HNA SET\n\n",
               nowtm->tm_hour,
@@ -334,11 +334,11 @@
   else
     OLSR_PRINTF(1, "IP net/prefixlen               GW IP\n");
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      struct hna_entry *tmp_hna = hna_set[index].next;
+      struct hna_entry *tmp_hna = hna_set[idx].next;
       /* Check all entrys */
-      while(tmp_hna != &hna_set[index])
+      while(tmp_hna != &hna_set[idx])
 	{
 	  /* Check all networks */
 	  struct hna_net *tmp_net = tmp_hna->networks.next;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/hysteresis.c olsrd-current/src/hysteresis.c
--- olsrd-0.5.3/src/hysteresis.c	2007-04-26 00:08:08.000000000 +0200
+++ olsrd-current/src/hysteresis.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: hysteresis.c,v 1.20 2007/04/25 22:08:08 bernd67 Exp $
+ * $Id: hysteresis.c,v 1.21 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 
@@ -164,16 +164,14 @@
 void
 update_hysteresis_incoming(union olsr_ip_addr *remote, struct interface *local, olsr_u16_t seqno)
 {
-  struct link_entry *link;
-
-  link = lookup_link_entry(remote, NULL, local);
+  struct link_entry *lnk = lookup_link_entry(remote, NULL, local);
 
   /* Calculate new quality */      
-  if(link != NULL)
+  if(lnk != NULL)
     {
-      link->L_link_quality = olsr_hyst_calc_stability(link->L_link_quality);
+      lnk->L_link_quality = olsr_hyst_calc_stability(lnk->L_link_quality);
 #ifdef DEBUG
-      OLSR_PRINTF(3, "HYST[%s]: %0.3f\n", olsr_ip_to_string(remote), link->L_link_quality);
+      OLSR_PRINTF(3, "HYST[%s]: %0.3f\n", olsr_ip_to_string(remote), lnk->L_link_quality);
 #endif
 
       /* 
@@ -183,26 +181,26 @@
        * been added to olsr_seqno there
        */
 
-      if (link->olsr_seqno_valid && 
-          (unsigned short)(seqno - link->olsr_seqno) < 100)
-	  while (link->olsr_seqno != seqno)
+      if (lnk->olsr_seqno_valid && 
+          (unsigned short)(seqno - lnk->olsr_seqno) < 100)
+	  while (lnk->olsr_seqno != seqno)
 	    {
-	      link->L_link_quality = olsr_hyst_calc_instability(link->L_link_quality);
+	      lnk->L_link_quality = olsr_hyst_calc_instability(lnk->L_link_quality);
 #ifdef DEBUG
 	      OLSR_PRINTF(5, "HYST[%s] PACKET LOSS! %0.3f\n",
-			  olsr_ip_to_string(remote), link->L_link_quality);
+			  olsr_ip_to_string(remote), lnk->L_link_quality);
 #endif
-	      if(link->L_link_quality < olsr_cnf->hysteresis_param.thr_low)
+	      if(lnk->L_link_quality < olsr_cnf->hysteresis_param.thr_low)
 		break;
 
-	      link->olsr_seqno++;
+	      lnk->olsr_seqno++;
 	    }
 
 
-      link->olsr_seqno = seqno + 1;
-      link->olsr_seqno_valid = OLSR_TRUE;
+      lnk->olsr_seqno = seqno + 1;
+      lnk->olsr_seqno_valid = OLSR_TRUE;
 
-      //printf("Updating seqno to: %d\n", link->olsr_seqno);
+      //printf("Updating seqno to: %d\n", lnk->olsr_seqno);
     }
   return;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/interfaces.c olsrd-current/src/interfaces.c
--- olsrd-0.5.3/src/interfaces.c	2007-05-14 00:23:55.000000000 +0200
+++ olsrd-current/src/interfaces.c	2007-08-02 23:51:40.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: interfaces.c,v 1.32 2007/05/13 22:23:55 bernd67 Exp $
+ * $Id: interfaces.c,v 1.33 2007/08/02 21:51:40 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -226,7 +226,7 @@
  */
 
 struct interface *
-if_ifwithaddr(union olsr_ip_addr *addr)
+if_ifwithaddr(const union olsr_ip_addr * const addr)
 {
   struct interface *ifp;
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/interfaces.h olsrd-current/src/interfaces.h
--- olsrd-0.5.3/src/interfaces.h	2007-05-14 00:23:55.000000000 +0200
+++ olsrd-current/src/interfaces.h	2007-08-02 23:51:40.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: interfaces.h,v 1.40 2007/05/13 22:23:55 bernd67 Exp $
+ * $Id: interfaces.h,v 1.41 2007/08/02 21:51:40 bernd67 Exp $
  */
 
 
@@ -206,7 +206,7 @@
 if_ifwithsock(int);
 
 struct interface *
-if_ifwithaddr(union olsr_ip_addr *);
+if_ifwithaddr(const union olsr_ip_addr *);
 
 struct interface *
 if_ifwithname(const char *);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/ipc_frontend.c olsrd-current/src/ipc_frontend.c
--- olsrd-0.5.3/src/ipc_frontend.c	2007-08-01 18:19:48.000000000 +0200
+++ olsrd-current/src/ipc_frontend.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: ipc_frontend.c,v 1.32 2007/08/01 16:19:48 bernd67 Exp $
+ * $Id: ipc_frontend.c,v 1.33 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 /*
@@ -335,7 +335,7 @@
 {
   struct rt_entry  *destination;
   struct interface *ifn;
-  olsr_u8_t        index;
+  int               idx;
   struct ipcmsg packet;
   char *tmp;
   
@@ -343,10 +343,10 @@
   if(!ipc_active)
     return 0;
   
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      for(destination = routingtable[index].next;
-	  destination != &routingtable[index];
+      for(destination = routingtable[idx].next;
+	  destination != &routingtable[idx];
 	  destination = destination->next)
 	{
 	  ifn = destination->rt_if;
@@ -390,10 +390,10 @@
 	}
     }
 
-  for(index=0;index<HASHSIZE;index++)
+  for(idx=0;idx<HASHSIZE;idx++)
     {
-      for(destination = hna_routes[index].next;
-	  destination != &hna_routes[index];
+      for(destination = hna_routes[idx].next;
+	  destination != &hna_routes[idx];
 	  destination = destination->next)
 	{
 	  ifn = destination->rt_if;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/link_set.c olsrd-current/src/link_set.c
--- olsrd-0.5.3/src/link_set.c	2007-04-26 00:08:09.000000000 +0200
+++ olsrd-current/src/link_set.c	2007-08-19 22:37:41.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: link_set.c,v 1.68 2007/04/25 22:08:09 bernd67 Exp $
+ * $Id: link_set.c,v 1.70 2007/08/19 20:37:41 bernd67 Exp $
  */
 
 
@@ -198,14 +198,14 @@
   for(ifs = ifnet; ifs != NULL; ifs = ifs->int_next)
     {
       struct mid_address   *aliases;
-      struct link_entry  *link;
+      struct link_entry  *lnk = lookup_link_entry(main_addr, NULL, ifs);
 
       //printf("\tChecking %s->", olsr_ip_to_string(&ifs->ip_addr));
       //printf("%s : ", olsr_ip_to_string(main_addr)); 
-      if((link = lookup_link_entry(main_addr, NULL, ifs)) != NULL)
+      if(lnk != NULL)
 	{
 	  //printf("%d\n", lookup_link_status(link));
-	  if(lookup_link_status(link) == SYM_LINK)
+	  if(lookup_link_status(lnk) == SYM_LINK)
 	    return SYM_LINK;
 	}
       /* Get aliases */
@@ -215,11 +215,12 @@
 	{
 	  //printf("\tChecking %s->", olsr_ip_to_string(&ifs->ip_addr));
 	  //printf("%s : ", olsr_ip_to_string(&aliases->address)); 
-            if((link = lookup_link_entry(&aliases->alias, NULL, ifs)) != NULL)
+            lnk = lookup_link_entry(&aliases->alias, NULL, ifs);
+            if(lnk != NULL)
 	    {
 	      //printf("%d\n", lookup_link_status(link));
 
-	      if(lookup_link_status(link) == SYM_LINK)
+	      if(lookup_link_status(lnk) == SYM_LINK)
 		return SYM_LINK;
 	    }
 	}
@@ -793,23 +794,29 @@
 static int
 check_link_status(struct hello_message *message, struct interface *in_if)
 {
+  int ret = UNSPEC_LINK;
   struct hello_neighbor  *neighbors;
 
   neighbors = message->neighbors;
   
   while(neighbors!=NULL)
     {
+      /*
+       * Note: If a neigh has 2 cards we can reach, the neigh
+       * will send a Hello with the same IP mentined twice
+       */
       if(COMP_IP(&neighbors->address, &in_if->ip_addr))
         {
 	  //printf("ok");
-	  return neighbors->link;
+	  ret = neighbors->link;
+	  if (SYM_LINK == ret) break;
 	}
 
       neighbors = neighbors->next; 
     }
 
 
-  return UNSPEC_LINK;
+  return ret;
 }
 
 
@@ -978,19 +985,19 @@
 static void update_packet_loss_worker(struct link_entry *entry, int lost)
 {
   unsigned char mask = 1 << (entry->loss_index & 7);
-  int index = entry->loss_index >> 3;
+  const int idx = entry->loss_index >> 3;
   double rel_lq, saved_lq;
 
   if (lost == 0)
     {
       // packet not lost
 
-      if ((entry->loss_bitmap[index] & mask) != 0)
+      if ((entry->loss_bitmap[idx] & mask) != 0)
         {
           // but the packet that we replace was lost
           // => decrement packet loss
 
-          entry->loss_bitmap[index] &= ~mask;
+          entry->loss_bitmap[idx] &= ~mask;
           entry->lost_packets--;
         }
     }
@@ -999,12 +1006,12 @@
     {
       // packet lost
 
-      if ((entry->loss_bitmap[index] & mask) == 0)
+      if ((entry->loss_bitmap[idx] & mask) == 0)
         {
           // but the packet that we replace was not lost
           // => increment packet loss
 
-          entry->loss_bitmap[index] |= mask;
+          entry->loss_bitmap[idx] |= mask;
           entry->lost_packets++;
         }
     }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/linux/link_layer.c olsrd-current/src/linux/link_layer.c
--- olsrd-0.5.3/src/linux/link_layer.c	2007-04-26 00:08:17.000000000 +0200
+++ olsrd-current/src/linux/link_layer.c	2007-08-20 01:00:15.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: link_layer.c,v 1.13 2007/04/25 22:08:17 bernd67 Exp $
+ * $Id: link_layer.c,v 1.14 2007/08/19 23:00:15 bernd67 Exp $
  */
 
 
@@ -69,14 +69,6 @@
 int
 add_spy_node(union olsr_ip_addr *, char *);
 
-
-extern char *
-sockaddr_to_string(struct sockaddr *);
-
-extern char *
-olsr_ip_to_string(union olsr_ip_addr *);
-
-
 #define	MAXIPLEN	60
 #define	MAXICMPLEN	76
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/lq_avl.c olsrd-current/src/lq_avl.c
--- olsrd-0.5.3/src/lq_avl.c	2007-07-06 00:43:46.000000000 +0200
+++ olsrd-current/src/lq_avl.c	2007-08-03 00:00:46.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: lq_avl.c,v 1.10 2007/07/05 22:43:46 bernd67 Exp $
+ * $Id: lq_avl.c,v 1.11 2007/08/02 22:00:46 bernd67 Exp $
  */
 
 #include <stddef.h>
@@ -53,7 +53,7 @@
  * dummy comparison pointer
  * set to zero for a fast inline ipv4 comparison
  */
-int (*avl_comp_default)(void *, void *) = 0;
+int (*avl_comp_default)(void *, void *) = NULL;
 
 int avl_comp_ipv4(void *ip1, void *ip2)
 {
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.3/src/lq_mpr.c olsrd-current/src/lq_mpr.c
--- olsrd-0.5.3/src/lq_mpr.c	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/src/lq_mpr.c	2007-08-03 00:07:19.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: lq_mpr.c,v 1.12 2007/02/10 19:27:32 bernd67 Exp $
+ * $Id: lq_mpr.c,v 1.13 2007/08/02 22:07:19 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -54,7 +54,6 @@
   struct neighbor_entry *neigh;
   double best, best_1hop;
   olsr_bool mpr_changes = OLSR_FALSE;
-  struct link_entry *link;
 
   for(i = 0; i < HASHSIZE; i++)
     {
@@ -108,12 +107,12 @@
 
               // determine the link quality of the direct link
 
-              link = get_best_link_to_neighbor(&neigh->neighbor_main_addr);
+              struct link_entry *lnk = get_best_link_to_neighbor(&neigh->neighbor_main_addr);
 
-	      if(!link)
+	      if (!lnk)
 		continue;
 
-              best_1hop = link->loss_link_quality * link->neigh_link_quality;
+              best_1hop = lnk->loss_link_quality * lnk->neigh_link_quality;
 
               // see wether we find a better route via an MPR
 
